﻿using Benday.FakesSample.Common;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Benday.FakesSample.DataAccess
{
    public class SqlPersonRepository : IRepository<IPerson>
    {
        public SqlPersonRepository()
        {
            _AdapterInstance = new PersonToDataRowAdapter();
        }

        private PersonToDataRowAdapter _AdapterInstance;
        public PersonToDataRowAdapter AdapterInstance
        {
            get { return _AdapterInstance; }
        }

        public IList<IPerson> GetAll()
        {
            throw new NotImplementedException();
        }

        public IPerson GetById(int id)
        {
            PersonDataAccess dataAccess = new PersonDataAccess();

            var datarow = dataAccess.LoadPerson(id);

            var person = new Person();

            _AdapterInstance.Adapt(datarow, person);

            return person;
        }

        public void Save(IPerson saveThis)
        {
            if (saveThis.Id == 0)
            {
                SaveNew(saveThis);
            }
            else
            {
                SaveExisting(saveThis);
            }
        }

        private void SaveNew(IPerson saveThis)
        {
            PersonDataAccess dataAccess = new PersonDataAccess();
                        
            var datarow =
                new FakesDataSet().Person.NewPersonRow();

            _AdapterInstance.Adapt(saveThis, datarow);

            dataAccess.SavePerson(datarow);

            saveThis.Id = datarow.Id;
        }

        private void SaveExisting(IPerson saveThis)
        {
            PersonDataAccess dataAccess = new PersonDataAccess();

            var datarow = dataAccess.LoadPerson(saveThis.Id);

            if (datarow == null)
            {
                throw new InvalidOperationException("Unknown person.");
            }

            _AdapterInstance.Adapt(saveThis, datarow);

            dataAccess.SavePerson(datarow);
        }

        public void Delete(IPerson deleteThis)
        {
            throw new NotImplementedException();
        }
    }
}